#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <ctime>
using namespace std;

const char FirstNames[31][16] = { "Axilleas", "Giorgos", "Giannis", "Nikos", "Xaris", "Kostas", "Manolis", "Alexandra", "Maria", 
"Dimitra", "Dimitris", "Konstantina", "Marilena", "Eleni", "Andreas", "Alexis", "Alexia", "Anastasia", "Tasos", "Thodoris", 
"Pavlos", "Markos", "Thewni", "Katerina", "Eva", "Aggeliki", "Eugenia", "Xaroula", "Xristos", "Leonidas", "Sofia" };

const char LastNames[][32] = { "Papadopoulos", "Papagewrgiou", "Papadakis", "Konstantinou", "Georgiadis", "Delis", 
"Xatzopoulos", "Triantafulos", "Papazafeiris", "Mpezos", "Staikos", "Papaloukas", "Vandoros" };

const char StreetNames[41][18] = { "Amalias", "Stadiou", "Panepistimiou", "Ethn. Antistaseos", "Vas.Konstantinou", "Patr. Ioakim", 
"Ippokratous", "Andrianoupoleos", "Smirnis", "Rethimnou", "Xaniwn", "Psiloriti", "Omirou", "El.Venizelou", "Kapodistriou", "Ithakis", 
"Skra", "Thiseos", "Kallirois", "Meg.Alexandrou", "Pontou", "Dilou", "Aspropotamou", "Mitropoleos", "Athinas", "Ag.Konstantinou", 
"3is Septemvriou", "Kaniggos", "Skoufa", "Solonos", "Kapnikareas", "Ermou", "Voulis", "Filolaou", "Vouliagmenis", "Ilioupoleos",
"Per. Kareas", "Milopotamou", "Ag. Dimitriou", "Frantzi", "Mixalakopoulou"};

const char AreaNames[29][16] = { "Athina", "N.Kosmos", "Kallithea", "N.Smirni", "Ag.Dimitrios", "Elliniko", "Glufada", "Voula", "Dafni",
"Kifisia", "Monastiraki", "Peristeri", "Aigalew", "Marousi", "Zografou", "Kaisariani", "Ymitos", "Pagkrati", "Peiraias", "Ampelokhpoi",
"Galatsi", "Patisia", "Kipseli", "Varimpompi", "Vouliagmeni", "Vari", "Tauros", "Ilioupoli", "Argiroupoli"};

const char CityNames[24][16] = { "Attiki", "Patra", "Xania", "Rethimno", "Hraklio", "Paros", "Naxos", "Milos", "Siros", "Sifnos", "Mukonos",
"Kos", "Rodos", "Kerkira", "Skiathos", "Skopelos", "Thessaloniki", "Drama", "Xanthi", "Kavala", "Serres", "Tripoli", "Sparti", "Kuparrisia"};

int main(int argc, char* argv[]) {
	char* _fname;
	char _buffer[128];
	int N;
	int rnd, rnd_2, rnd_3, rnd_4, rnd_5, rnd_6, rnd_7;
	FILE* _out_file = NULL;
	if(argc < 3) {
		printf("Usage: ./file_Creator <output_file_name> <number of records>\n");
		return 1;
	}
	if(argv[1] != NULL && strlen(argv[1]) > 0) {
		_fname = (char*) malloc(sizeof(char)*strlen(argv[1]) + 1);
		strcpy(_fname, argv[1]);
	}
	if(argv[2] != NULL && strlen(argv[2]) > 0) {
		N = atoi(argv[2]);
		if(N < 0) {
			printf("Please enter a number of records > 0.\n");
			free(_fname);
			return 1;	
		}
	}
	srand(time(NULL));
	_out_file = fopen(_fname, "w");
	if(_out_file == NULL) {
		printf("Error occured while creating file.\n");
		free(_fname);
		return 1;	
	}
	for(int i = 0; i < N; i++) {
		memset(_buffer, 0, 128*sizeof(char));
		rnd = rand() % 1000000000 + 1000000000;
		rnd_2 = rand() % 31;
		rnd_3 = rand() % 13;
		rnd_4 = rand() % 41;
		rnd_5 = rand() % 99;
		rnd_6 = rand() % 29;
		rnd_7 = rand() % 24;
		fprintf(_out_file, "%d; %s %s; %s %d,%s,%s;\n", rnd, FirstNames[rnd_2], LastNames[rnd_3], StreetNames[rnd_4], rnd_5, AreaNames[rnd_6], CityNames[rnd_7]);
	}
	free(_fname);
	fclose(_out_file);
	return 0;
}
